searchData={"items":[{"type":"module","title":"AI","doc":"Documentation for `AI`.","ref":"AI.html"},{"type":"function","title":"AI.chat/1","doc":"Parses out OpenAI's chat completion response into a cleaner format.\nReturns {:ok, text_content} or {:error, message}\n\nInstead of:\n{:ok,\n%{\n id: \"chatcmpl-7zSc1rsCXpyALMjM9MkaF077xYRot\",\n usage: %{\n   \"completion_tokens\" => 10,\n   \"prompt_tokens\" => 19,\n   \"total_tokens\" => 29\n },\n created: 1694882349,\n choices: [\n   %{\n     \"finish_reason\" => \"stop\",\n     \"index\" => 0,\n     \"message\" => %{\n       \"content\" => \"Compact and stack snow blocks in a dome shape.\",\n       \"role\" => \"assistant\"\n     }\n   }\n ],\n model: \"gpt-3.5-turbo-0613\",\n object: \"chat.completion\"\n}}","ref":"AI.html#chat/1"},{"type":"function","title":"AI.sigil_LLM/2","doc":"DEPRECATED: Use ~l instead. ~LLM doesn't work with string interpolation.\n\nImplements the ~LLM sigil, which parses text into an OpenAI friendly chat completion prompt.\n~LLM works by parsing out the `model`, `system`, `user` and `assistant` keywords.","ref":"AI.html#sigil_LLM/2"},{"type":"function","title":"Examples - AI.sigil_LLM/2","doc":"iex> import AI\niex> ~LLM\"model: gpt-3.5-turbo system: You are an expert at text to image prompts. Given a description, write a text-to-image prompt. user: sunset\"\n[\n  model: \"gpt-3.5-turbo\",\n  messages: [\n    %{\n      content: \"You are an expert at text to image prompts. Given a description, write a text-to-image prompt.\",\n      role: \"system\"\n    },\n    %{content: \"sunset\", role: \"user\"}\n  ]\n]","ref":"AI.html#sigil_LLM/2-examples"},{"type":"function","title":"AI.sigil_l/2","doc":"Implements the ~l sigil, which parses text into an OpenAI friendly chat completion prompt.\n~l works by parsing out the `model`, `system`, `user` and `assistant` keywords.\n\nSupports string interpolation.","ref":"AI.html#sigil_l/2"},{"type":"function","title":"Examples - AI.sigil_l/2","doc":"iex> import AI\niex> ~l\"model: gpt-3.5-turbo system: You are an expert at text to image prompts. Given a description, write a text-to-image prompt. user: sunset\"\n[\n  model: \"gpt-3.5-turbo\",\n  messages: [\n    %{\n      content: \"You are an expert at text to image prompts. Given a description, write a text-to-image prompt.\",\n      role: \"system\"\n    },\n    %{content: \"sunset\", role: \"user\"}\n  ]\n]","ref":"AI.html#sigil_l/2-examples"},{"type":"extras","title":"AI","doc":"# AI\n\nHelpers for using AI in Elixir. Currently requires the [OpenAI](https://github.com/mgallo/openai.ex) package.\n\nIncludes `~l` sigil and `chat/1` function for OpenAI generation.\n\n```elixir\niex> ~l\"model:gpt-3.5-turbo user: how do I build an igloo in 10 words?\"\n[\n  model: \"gpt-3.5-turbo\",\n  messages: [%{role: \"user\", content: \"how do I build an igloo in 10 words?\"}]\n]\n```\n\n```elixir\niex> ~l\"model:gpt-3.5-turbo user: how do I build an igloo in 10 words?\" |> chat()\n{:ok, \"Stack snow blocks in circle, decreasing size upward, till enclosed\"}\n```","ref":"readme.html"},{"type":"extras","title":"Installation - AI","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed by adding `ai` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ai, \"~> 0.3.4\"},\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Why? - AI","doc":"[Here's why!](https://www.charlieholtz.com/articles/elixir-ai)","ref":"readme.html#why"},{"type":"extras","title":"CHANGELOG","doc":"## [0.3.4] - 2022-01-01\n\n#","ref":"changelog.html"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- Recommend using `~l` instead of `~LLM`, as it allows for interpolation.","ref":"changelog.html#changed"}],"content_type":"text/markdown"}